Especifica dependencias en Python

Existen dos formas de especificar las dependencias para las funciones de Cloud Functions escritas en Python: usar el archivo requirements.txt del administrador de paquetes pip o empaquetar las dependencias locales junto con tu función.

La especificación de dependencias que usa el estándar Pipfile/Pipfile.lock no es compatible en la actualidad. Tu proyecto no debe incluir estos archivos.

Especifica dependencias con pip

Las dependencias en Python se administran con pip y se expresan en un archivo de metadatos llamado requirements.txt. Este archivo debe estar en el mismo directorio que el archivo main.py que contiene el código de tu función.

Cuando implementas tu función, Cloud Functions descarga e instala dependencias declaradas en el archivo requirements.txt mediante pip.

El archivo requirements.txt contiene una línea por paquete. Cada línea contiene el nombre del paquete y, opcionalmente, la versión solicitada. Para obtener más detalles, consulta la referencia requirements.txt.

El siguiente es un ejemplo de archivo requirements.txt:

requests==2.20.0
numpy

Empaqueta las dependencias locales

Puedes empaquetar y, además, implementar dependencias junto con tu función. Este enfoque es útil si tu dependencia no está disponible a través del administrador de paquetes pip o si el acceso a Internet del entorno de Cloud Functions está restringido.

Por ejemplo, puedes usar una estructura de directorio como la que se muestra a continuación:

myfunction/
├── main.py
└── localpackage/
    ├── __init__.py
    └── script.py

Luego, puedes importar el código como de costumbre desde localpackage con la siguiente declaración import.

# Code in main.py
from localpackage import script

Ten en cuenta que este enfoque no ejecutará ningún archivo setup.py. Los paquetes con esos archivos aún se pueden agrupar, pero es posible que no se ejecuten correctamente en Cloud Functions.

Usa dependencias privadas

Las dependencias se instalan en un entorno de Cloud Build que no proporciona acceso a las Llaves SSH. Los paquetes que se alojan en repositorios que requieren una autenticación basada en SSH se deben copiar y subir junto con el código del proyecto, como se describe en la sección anterior.

Puedes usar el comando pip install con el marcador -t DIRECTORY para copiar las dependencias privadas en un directorio local antes de implementar tu aplicación, de la siguiente manera:

  1. Copia tu dependencia en un directorio local:

    pip install -t DIRECTORY DEPENDENCY
  2. Agrega un archivo __init__.py vacío al directorio DIRECTORY para convertirlo en un módulo.

  3. Importa desde este módulo para usar tu dependencia:

    import DIRECTORY.DEPENDENCY

Paquetes preinstalados

Los siguientes paquetes de Python se instalan automáticamente junto con tu función durante la implementación. Si usas alguno de estos paquetes en el código de tu función, te recomendamos que incluyas las siguientes versiones en el archivo requirements.txt:

Python 3.7

aiohttp==3.6.2
async-timeout==3.0.1
attrs==19.3.0
cachetools==4.1.1
certifi==2020.6.20
chardet==3.0.4
click==7.1.2
Flask==1.1.2
google-api-core==1.21.0
google-api-python-client==1.10.0
google-auth==1.19.2
google-auth-httplib2==0.0.4
google-cloud-core==1.3.0
google-cloud-trace==0.23.0
googleapis-common-protos==1.52.0
grpcio==1.30.0
httplib2==0.18.1
idna==2.9
itsdangerous==1.1.0
Jinja2==2.11.2
MarkupSafe==1.1.1
multidict==4.7.6
opencensus==0.7.9
opencensus-context==0.1.1
pip==20.1.1
protobuf==3.12.2
pyasn1==0.4.8
pyasn1-modules==0.2.8
pytz==2020.1
PyYAML==5.3.1
requests==2.24.0
rsa==4.6
setuptools==47.3.1
six==1.15.0
uritemplate==3.0.1
urllib3==1.25.9
Werkzeug==1.0.1
wheel==0.34.2
wrapt==1.12.1
yarl==1.5.1

Python 3.8

cachetools==4.2.2
certifi==2021.5.30
charset-normalizer==2.0.6
click==7.1.2
cloudevents==1.2.0
deprecation==2.1.0
flask==1.1.2
functions-framework==2.2.1
google-auth==2.2.0
gunicorn==20.0.4
idna==3.2
itsdangerous==1.1.0
jinja2==2.11.2
markupsafe==1.1.1
packaging==21.0
pathtools==0.1.2
pip==21.1.1
pyasn1-modules==0.2.8
pyasn1==0.4.8
pyparsing==2.4.7
requests==2.26.0
rsa==4.7.2
setuptools==58.1.0
urllib3==1.26.7
watchdog==1.0.2
werkzeug==1.0.1

Python 3.9

cachetools==4.2.2
certifi==2021.5.30
charset-normalizer==2.0.6
click==7.1.2
cloudevents==1.2.0
deprecation==2.1.0
flask==1.1.2
functions-framework==2.2.1
google-auth==2.2.0
gunicorn==20.0.4
idna==3.2
itsdangerous==1.1.0
jinja2==2.11.2
markupsafe==1.1.1
packaging==21.0
pathtools==0.1.2
pip==21.1.3
pyasn1-modules==0.2.8
pyasn1==0.4.8
pyparsing==2.4.7
requests==2.26.0
rsa==4.7.2
setuptools==58.1.0
urllib3==1.26.7
watchdog==1.0.2
werkzeug==1.0.1

Además, el entorno de ejecución de Python incluye una serie de paquetes de sistema en el entorno de ejecución. Si tu función usa una dependencia que requiere un paquete de sistema que no está en la lista, puedes solicitar un paquete.